module.exports = function(){
  var _bluno=this;
  _bluno.status="---";
  _bluno.connect_callback=null;
  _bluno.scanning=function(){
    if(_bluno.status=="ready"){
      _bluno.device.setStatus('scanning');
      _bluno.status="scanning";
      noble.startScanning();
    }
    else{
      setTimeout(function(){
        _bluno.scanning();
      },200);
    }
  };
  
  _bluno.connect=function(device,callback){
    _bluno.device=device;
    
    if(_bluno.connect_callback==null){
      _bluno.connect_callback=callback;
      if(!_bluno.device.connected()){
        _bluno.scanning();
        
        setTimeout(function(){
          if(_bluno.status=="scanning"){    
            if(_bluno.connect_callback!=null){
              _bluno.connect_callback('scanning timeout!');
              _bluno.connect_callback=null;
            }
            noble.stopScanning();
          }
        },10000);/**/
      }
      else{
        if(_bluno.connect_callback!=null){
          _bluno.connect_callback('already connected');
          _bluno.connect_callback=null;
        }
      }
    }
    else{
      var tmp_callback=callback;
      setTimeout(function(){
        _bluno.connect(_bluno.device,tmp_callback);
      },100);
    } 
  };
  
  var noble = require('noble');
  noble.on('scanStart', function(){
    //console.log('[event]','scanStart',_bluno.device.address());
  });
  noble.on('scanStop', function(){
    //console.log('[event]','scanStop');
    _bluno.status="ready";
  });
  noble.on('stateChange', function(state) {
    //console.log('[event]','stateChange',state);
    if (state === 'poweredOn') {
      _bluno.status="ready";
      //noble.startScanning();
    } else {
      //_bluno.status="ready";
      noble.stopScanning();
    }
  });
  noble.on('discover', function(peripheral) {
    //console.log('[event]','\t','discover',peripheral.address);
    if(peripheral.address==_bluno.device.address()){
      noble.stopScanning();
      _bluno.device.setPeripheral(peripheral);
      
      peripheral.connect(function(error) {
        peripheral.discoverServices([], function(error, services) {
          //console.log('\tdiscoverServices', services.length);
          for(var i = 0; i < services.length ; i++ ){
            //console.log('\tservice',i,services[i].uuid,_bluno.device.uuid('service'));
            if(services[i].uuid==_bluno.device.uuid('service')){
              services[i].discoverCharacteristics([], function(error, characteristics) {
                for(var j=0;j<characteristics.length;j++){
                  //console.log('\tcharacteristic',j,characteristics[j].uuid,_bluno.device.uuid('tx'));
                  if(characteristics[j].uuid==_bluno.device.uuid('tx')){
                    var characteristic=characteristics[j];
                    _bluno.device.setCharacteristic('tx',characteristic);
                    _bluno.device.setStatus('connected');
                    if(_bluno.connect_callback!=null){
                      _bluno.connect_callback('connected');
                      _bluno.connect_callback=null;
                    }
                    //console.log('connected');
                  }
                }//for j
              });//discoverCharacteristics
            }
          }//for i
        });//discoverServices
      });//connect
    }
  });//discover
};

//---------