module.exports = function(item /*name,address,uuid_service,uuid_tx,uuid_rx*/){
  var device={
    "name": item.name,
    "address": item.address,
    "uuid": {
      "service": item.uuid.service,
      "tx": item.uuid.tx,
      "rx": item.uuid.rx,
    },
    "action":item.action,
    "peripheral": null,
    "characteristic":{},
    "status": "ready",
  };
  this.action=function(type){
    return device.action.types.indexOf(type)!==-1;
  };
  this.actiontime=function(){
    return device.action.time;
  };
  this.actionscript=function(){
    return device.action.script;
  };
  this.name=function(){
    return device.name;
  };
  this.address=function(){
    return device.address;
  };
  this.uuid=function(key){
    //console.log('uuid',device.uuid,key,device.uuid[key]);
    return device.uuid[key];
  };
  
  this.connected=function(){
    //console.log('connected',device.status);
    return device.status=="connected";
  };
  
  this.write=function(str){
    var characteristic=device.characteristic['tx'];
    
    if((device.status=="connected") && characteristic){
      //if(str!=='*')
      //  console.log('write',device.address,str);
      device.characteristic['tx'].write(Buffer.from(str));
      return true;
    }
    else{
      //if(str!=='*')
      //  console.log('pass',device.address,'------------',str);
    }/**/
    return false;
  };
  
  
  this.connectTest=function(){
    if(device.status=='connected'){
      this.write('*');
      var _this=this;
      setTimeout(function(){
        _this.connectTest();
      },1000);
    }
  };
    
  this.status=function(){
    return device.status;
  };
  this.setStatus=function(status){
    device.status=status;
    if(device.status=='connected'){
      this.connectTest();
    }
  };
  this.setCharacteristic=function(key,characteristic){
    device.characteristic[key]=characteristic;
  };
  
  this.setPeripheral=function(peripheral){
    device.peripheral=peripheral;
    device.peripheral.once('disconnect',function(){
      console.log('[event]','disconnect',this.address);
      device.status="ready";
    });
  };
  
};
