const Log=require('./log');

module.exports = function(obj){
  var raspi = require('raspi');
  var Serial = require('raspi-serial').Serial;
  var _this=this;
  _this.obj=obj;
  _this.obj.is_connected=false;
  _this.buffer=new Buffer([]);
  _this.write=function (cmd){
    try{
      if(_this.obj.is_connected){
        //console.log('[write] oo ',cmd);
        _this.serial.write(cmd+"\r\n");
        _this.obj.t3=new Date().getTime();
        setTimeout(function(){
          if(_this.obj.is_connected){
            if(_this.obj.t3-_this.obj.t2>10000){
              _this.obj.is_connected=false;
              console.log('████████████████████████████████████████████████████████████████████████████████████████████████');
              console.log('serial write error: ',_this.obj.t2,_this.obj.t3,_this.obj.t3-_this.obj.t2);
              _this.obj.onErrorClose('serial write error');
              
            }
          }
        },500);
      }
      else{
        //console.log('[write] xx ',cmd);
      }
      if(_this.obj.debug)
        console.log('uart','write: '+cmd);
    }
    catch(e){
    }
  };
  _this.onData=function(data){
    _this.obj.onData(data);
    
    if(_this.obj.debug)
      console.log('uart','onData: '+data.toString());
    
    _this.buffer=Buffer.concat([_this.buffer,data]);
    var idx=-1;
    do{
      idx=_this.buffer.indexOf("0d0a", "hex");
      if(idx!== -1){
        line=_this.buffer.slice(0,idx);
        _this.obj.onReadLine(line.toString());
        _this.buffer=_this.buffer.slice(idx+2);
      }
    }while(idx!==-1);
  };
  raspi.init(function(){
    _this.obj.onInited();
  });
  
  _this.connect=function(){
    _this.obj.connect.parity=Serial.PARITY_NONE;
    
    _this.obj.t1=false;
    _this.obj.t2=new Date().getTime();
    _this.obj.t3=new Date().getTime();
  
    _this.serial = new Serial(_this.obj.connect);
    _this.serial.open(function(){
      _this.obj.t1=true;
      _this.obj.is_connected=true;
      _this.serial.on('data', function(data){
        //console.log('[data]',Math.random());
        _this.obj.t2=new Date().getTime();
        _this.onData(data);
      });
      _this.obj.onOpened();
    });
    
    setTimeout(function(){
      if(!_this.obj.t1){
        _this.obj.is_connected=false;
        _this.obj.onErrorClose('serial connect error');
      }
    },1000);
  };
  
};