#!/bin/bash
__ROOT__=$(dirname $(realpath $0))
cd $__ROOT__
. config.txt 2>/dev/null

echo "--------------------------------"
echo "time: " $(date)
echo "UPDATE_INTERVAL: ${UPDATE_INTERVAL}"


#############################################
if [ $1 -eq 0 ]; then
  DATE=$(date +%s)
  #DATE_s=$(($DATE % 60))
  DATE_m=$((($DATE / 60)%60))
  #DATE_h=$(((8+$DATE / 3600)%24))

  #允許每十分鐘被執行一次
  if [ $(($DATE_m % $UPDATE_INTERVAL)) -ne 0 ]; then
    echo "Pass"
    exit
  fi

  #亂數暫停 30~60秒
  SLEEP_TIME=$[( $RANDOM % $SLEEP_RAND_TIME2 )  + $SLEEP_RAND_TIME1];
  echo "sleep ${SLEEP_TIME} sec"
  sleep ${SLEEP_TIME}s  
fi
#############################################

CVERSION=$(cat .cversion 2>/dev/null || echo 0.0.0)
NVERSION=$(curl -sS ${GIT_URL}/raw/master/.nversion)

echo "CVERSION: ${CVERSION}"
echo "NVERSION: ${NVERSION}"

if [ "${NVERSION}" != "${CVERSION}" ] && [ "${NVERSION}" != "" ]; then
  if [ $1 -lt 2 ]; then #判斷是否為非安裝狀態
    echo "更新...update.sh"
    bash update.sh
  fi
  #將版本資訊寫入.cversion
  echo "版本: ${CVERSION} --> ${NVERSION}"
  echo ${NVERSION} > .cversion
  echo "執行start.sh 01"
  bash start.sh 1 
  
  sudo ${__ROOT__}/nodejs/geolocation/install.sh
else
  echo "不需更新"
  if [ $1 -gt 0 ]; then #是否要強制執行 start.sh
    echo "執行start.sh 02"
    bash start.sh 0
  fi
fi


#執行nodejs
sudo ${__ROOT__}/nodejs/geolocation/start.sh $(hostname) $(cat .cversion 2>/dev/null || echo 0.0.0)
