#!/bin/bash

#############################################

__ROOT__=$(dirname $(realpath $0))
cd $__ROOT__

#取得版本資訊
CVERSION=$(cat .cversion 2>/dev/null || echo 0.0.0)

#網路校時
sudo ntpdate -u time.stdtime.gov.tw >/dev/null 2>&1

sudo kill $(ps axu | grep pishutdown.py | awk '{print $2}') 2>/dev/null
sudo -i -u $SUDO_USER bash -c 'sudo nohup python '"$__ROOT__"'/python/pishutdown.py >/dev/null 2>&1 &'


#停止先前的container
docker stop $(docker ps | grep cbsiot- | awk '{print $1}') >/dev/null 2>&1

#刪除所有 cbs 相關的 container
#docker rm -f $(docker ps -a | grep cbsiot- | awk '{print $1}') >/dev/null 2>&1

#刪除舊的image
docker rmi $(docker images | grep none | awk '{print $3}') >/dev/null 2>&1

#設定變數
DATE=$(date +%s)

#取得系統IP
_IP=$(hostname -I) || true

#啟動一個新的containter
sudo -i -u $SUDO_USER docker run \
  -d \
  --privileged \
  --net=host \
  --name cbsiot-${CVERSION}_${DATE} \
  -e HOST_HOSTNAME=$(hostname) \
  -e HOST_IP="${_IP}" \
  -e CVERSION=${CVERSION} \
  -v /run/systemd:/run/systemd \
  -v /etc/localtime:/etc/localtime:ro \
  -v /dev/ttyUSB2:/dev/ttyS0 \
  -v /etc/wpa_supplicant/wpa_supplicant.conf:/data/wifi.conf \
  dkr.tw/cbsiot-client bash -c "hciconfig hci0 reset && node main.js ${1} 1"
